#Agent.py
from Tools import *
from turtle import *

register_shape("school1/pupilNero.gif")
register_shape("school1/pupilVerde.gif")
register_shape("school1/pupilRosso.gif")
register_shape("school1/pupilGiallo.gif")
register_shape("school1/pupilSpecial.gif")
register_shape("desk",((5,-15),(15,-15),(15,15),(5,15)))

class Agent(Turtle):
    def __init__(self, number,myWorldState,
                 xPos, yPos, lX =-20,rX=19, lY=-20,rY=19, agType=""):
        Turtle.__init__(self)
        
        # the environment
        self.agOperatingSets=[]
        self.number = number
        self.lX = lX
        self.rX = rX
        self.lY = lY
        self.rY = rY
        self.myWorldState = myWorldState
        self.agType=agType
        # the agent
        self.xPos = xPos
        self.yPos = yPos
        self.deltaAtt=0
        print "agent", self.agType, "#", self.number, \
     	      "has been created at", self.xPos, ",", self.yPos

        # turtle behavior
        self.speed(0)
        self.penup()
        self.color("black")
        self.setx(self.xPos*1)
        self.sety(self.yPos*1)

        self.attention=0
        self.stepAttention=0
        self.nMethods=0

    def setColor(self,color):
        self.color(color)
        if color=="black"  : self.shape("school1/pupilNero.gif")
        if color=="green"  : self.shape("school1/pupilVerde.gif")
        if color=="red"    : self.shape("school1/pupilRosso.gif")
        if color=="yellow" : self.shape("school1/pupilGiallo.gif")
        if color=="violet" : self.shape("school1/pupilSpecial.gif")
        
        if color=="brown"  : self.shape("desk")

    # add an operating  set
    def setAnOperatingSet(self,aSet):
        self.agOperatingSets.append(aSet)

    # get operating set list
    def getOperatingSetList(self):
        return self.agOperatingSets

    # reset values
    def setNewCycleValues(self):
        self.deltaAtt=0
        #self.attention=random.randint(0,5)
        #self.attention=0

    # attention (total value until previous step)
    def getAttention(self):
        return self.attention
        
    # attention (with the last step)
    def getAttentionAndCleanStep(self):
        self.attention+=self.stepAttention
        self.stepAttention=0
        self.nMethods=0
        return self.attention

    # ",**d" in the parameter lists of the methods is a place holder
    # in case we use, calling the method, a dictionary as last param.

    # asking
    def ask(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm asking something!"
        add=0.5
        self.nMethods+=1
        self.stepAttention = (self.stepAttention*(self.nMethods-1) \
                             + add)                                 \
                             / self.nMethods

        self.write("Asking!!!", font=("Arial", 14)) # turtle action

    # fidgeting
    def fidget(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm fidgeting"
        add=random.random()*0.3+0.7
        self.nMethods+=1
        self.stepAttention = (self.stepAttention*(self.nMethods-1) \
                             + add)                                 \
                             / self.nMethods

    # paying attention
    def payAttention(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm paying attention"
        add=1
        self.nMethods+=1
        self.stepAttention = (self.stepAttention*(self.nMethods-1) \
                             + add)                                 \
                             / self.nMethods

    # shaking
    def shake(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm shaking"
        if self.agType == "verdePupil":
            add=random.random()*0.3+0.6
        else: add=random.random()*0.4+0.4
        self.nMethods+=1
        self.stepAttention = (self.stepAttention*(self.nMethods-1) \
                             + add)                                 \
                             / self.nMethods

        self.setx(self.xPos+random.random()*30-15)
        self.sety(self.yPos+random.random()*30-15)

        self.write("Shaking", font=("Arial", 16)) # turtle action

    # sitting down not well
    def sitDownNotWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm sitting down not well"

        # not relevant for attention

        self.setx(self.xPos+random.random()*20-10)
        self.sety(self.yPos+random.random()*20-10)


    # sitting down well
    def sitDownWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm sitting down well"

        # not relevant for attention

        self.setx(self.xPos)
        self.sety(self.yPos)

    # talking
    def talk(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm talking"
        add=0
        self.nMethods+=1
        self.stepAttention = (self.stepAttention*(self.nMethods-1) \
                             + add)                                 \
                             / self.nMethods

        self.write("bla bla", font=("Arial", 14)) # turtle action

    # talking closely
    def talkClose(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm talking closely"
        if self.agType == "verdePupil":
            add=random.random()*0.3+0.6
        else: add=random.random()*0.4+0.4
        self.nMethods+=1
        self.stepAttention = (self.stepAttention*(self.nMethods-1) \
                             + add)                                 \
                             / self.nMethods

        self.write("ps ps", font=("Arial", 12)) # turtle action

    # answering (bad)
    def answerBad(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "answering bad"
        add=1
        self.nMethods+=1
        self.stepAttention = (self.stepAttention*(self.nMethods-1) \
                             + add)                                 \
                             / self.nMethods

        self.write("answ Bad", font=("Arial", 14)) # turtle answ

    # answering (well)
    def answerWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "answering well"
        add=1
        self.nMethods+=1
        self.stepAttention = (self.stepAttention*(self.nMethods-1) \
                             + add)                                 \
                             / self.nMethods

        self.write("answ Well", font=("Arial", 14)) # turtle answ


    # the action, also jumping
    def randomMovement(self,**k):
        if random.random()<=self.myWorldState.getGeneralMovingProb():
            print "%s agent # %d moving" % (self.agType,self.number)
            self.jump=k["jump"]
            dx=randomMove(self.jump)
            self.xPos +=dx
            dy=randomMove(self.jump)
            self.yPos += dy
            #self.xPos = (self.xPos + self.worldXSize) % self.worldXSize
            #self.yPos = (self.yPos + self.worldYSize) % self.worldYSize
            if self.xPos < self.lX : self.xPos=self.lX
            if self.xPos > self.rX : self.xPos=self.rX
            if self.yPos < self.lY : self.yPos=self.lY
            if self.yPos > self.rY : self.yPos=self.rY

            self.attention-=0.25

            if abs(dx) > 4 and abs(dy) > 4 :
                self.attention-=0.25
    
            # modify actionGroup "move"
                actionGroup=actionDictionary.get("move","none")
                                    # in case, return "none"
        
                if actionGroup=="none": print "warning, actionGroup not found "+\
                                "in agent "+ str(self.number)
            
                else:
                    actionGroup.setLocalCode(actionGroup.getLocalCode()+\
                                "print 'agent %s # %d made a big jump';" \
                                             % (self.agType,self.number))
                    self.write("I jumped",font=("Arial", 14)) # acting as a turtle

        # tutle reports
        #self.clear()
        self.setx(self.xPos*1)
        self.sety(self.yPos*1)

    # report
    def reportPosition(self,**d):
        print self.agType, "#", self.number, "is at X =", \
               self.xPos, " Y =", self.yPos

    def getAgType(self):
        return self.agType

    # methods for Tk graphic applications
    def getXPos(self):
        return self.xPos

    def getYPos(self):
        return self.yPos

    def setGraphicItem(self, grI):
        self.graphicItem=grI

    def getGraphicItem(self):
        return self.graphicItem

# returns -1, 0, 1  with equal probability
def randomMove(jump):
    return random.randint(-1, 1)*jump
